default: run diff clean

run: FORCE
	@$(JAVAC) -cp $(CLASSPATH) Source.java -d .
	@$(EXEC) -cp $(CLASSPATH) -dasm pack.Source | grep -v '  .frame' | grep -v '  .max_stack' | grep -v '  .max_locals' > tmp.j
	@rm -fr pack
	@$(EXEC) -cp $(CLASSPATH) -compute-stacks -asm tmp.j > /dev/null
	@$(EXEC) -cp $(CLASSPATH) -dasm pack.Source > result
	@$(JAVA) -cp $(CLASSPATH) -Xverify:all -XX:-FailOverToOldVerifier pack.Source

diff: FORCE
	@diff -q result reference

clean: FORCE
	@rm -fr pack tmp.j result

FORCE:
